#!/usr/bin/perl
use strict;
use warnings;


my $from=1;
my $times=10;

if(@ARGV != 1){
  die "USAGE: <this> estimated_genome_size\n";
}

my $estimated_genome_size = $ARGV[0];
if($estimated_genome_size <= 0){
  die "estimated_genome_size must be > 0\n";
}

printf STDERR ("%s is given\n",$estimated_genome_size);
#exit;

my $bashcommand="";

my $suffix = "top20x";

printf STDERR ("start fa2fq -n\n");

for(my $i=$from; $i<$from+$times; ++$i){
  my $prefix=sprintf("c%02d.fin",$i);
  $bashcommand .= "(gzip -d -c ../$prefix.fa.gz | get_top_20x_fa.pl - -g $estimated_genome_size | fa2fq.pl -n - > $prefix.$suffix.fastq) &\n";
}

`
  $bashcommand
  wait
`;
printf STDERR ("done fa2fq\n");

printf STDERR ("making a manifest file\n");

for(my $i=$from; $i<$from+$times; ++$i){
  my $prefix=sprintf("c%02d.fin",$i);
  my $manifest="$prefix.$suffix.conf";
  open my $fh, ">", $manifest or die "cannot open $manifest: $!\n";
  printf $fh ("project=%s\n%s\n%s\n",
    $prefix.".".$suffix,
    "job=genome,denovo,accurate",
    "parameters = -MI:stop_on_nfs=no");
  printf $fh ("\n");
  printf $fh ("%s\n%s\n%s\n",
    "readgroup=bar",
    "technology=pcbiohq",
    "data=$prefix.$suffix.fastq");
  close $fh;
}

printf STDERR ("start mira\n");
my $command = "";
for(my $i=$from; $i<$from+$times; ++$i){
  my $prefix=sprintf("c%02d.fin",$i);
  my $manifest="$prefix.$suffix.conf";
  $prefix .= ".$suffix";
  $command .= "mira $manifest | tee do_$prefix.log & ";
#  `mira $manifest | tee do_$prefix.log`;
  #`bin/runCA stopAfter=unitigger -dir $prefix -p $prefix -s $spec $prefix.frg |& tee do_$prefix.log`;
}
`$command`;

