#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
//#include <zlib.h>
//#include "row2fqcell.h"

//#define INSMAX 31
#define LNAME 256
//#define LSEQ 32768
//#define LBUF (3*LSEQ)
int LSEQ = 32768;
//#define LVOTES (LSEQ*(1+INSMAX))
#define LAUX 32
#define AIDX 0
#define CIDX 1
#define GIDX 2
#define TIDX 3
#define NIDX 4
#define DELIDX 5
#define BASEKINDS 6
#define BANDWIDTH 8
#define BALLOT_BOX_SIZE 8

// ~depth
#define NROWS 256

#define BUFSIZE (2*NROWS)

#define LISTSIZE (128*1024)

unsigned long long INTERVAL=3ull;//>0ull
unsigned long long max_read_length;


//int VALID_VOTER = 10; // about half depth
//int VALID_VOTER = 20; // about depth
int VALID_VOTER = 1024;
//int VALID_LENGTH = 500;
int VALID_LENGTH = 1;

int valid_depth=4;

// I'll delete this variable
int max_num_u = 1;

int max_ins = 31;//TODO checked by if(num > MAXINS) but...

typedef struct regions_t{
  unsigned long long stt;
  unsigned long long end;
}regions_t;

typedef struct cigar_t{
  int num;
  char sym;
}cigar_t;

typedef struct cmaux_t{
  char sym;
  int num;
}cmaux_t;

typedef struct sam_t{
  char * qname;
  int flag;
  char * rname;
  int pos;
  int mapq;
  struct cigar_t * cigar;
  int cigar_length;
  char * rnext;
  int pnext;
  int tlen;
  char * seq;
  char * qual;
  char * tmp;
  char * unq;
  char as[LAUX];
  char ev[LAUX];
  int bit_score;
  double evalue;
}sam_t;

typedef struct base_t{
  char base;
  char qv;
//  int flag;
}base_t;

void print_sam(sam_t * s){
  printf("%s",s->qname);
  printf("\t");
  printf("%d",s->flag);
  printf("\t");
  printf("%s",s->rname);
  printf("\t");
  printf("%d",s->pos);
  printf("\t");
  printf("%d",s->mapq);
  printf("\t");
  int i;
  for(i=0; i<s->cigar_length; ++i){
    printf("%d%c",s->cigar[i].num,s->cigar[i].sym);
  }
  printf("\t");
  printf("%s",s->rnext);
  printf("\t");
  printf("%d",s->pnext);
  printf("\t");
  printf("%d",s->tlen);
  printf("\t");
  printf("%s",s->seq);
  printf("\t");
  printf("%s",s->qual);
  //printf("*");
  printf("\t");
  printf("%s",s->as);
  printf("\t");
  printf("%s",s->ev);
  printf("\n");
  return;
}

void init_sam(sam_t * s){
  s->qname = (char*)malloc(sizeof(char)*LNAME);
  if(s->qname == NULL){
    fprintf(stderr,"cannot allocate memory: qname\n");
    abort();
  }
  s->rname = (char*)malloc(sizeof(char)*LNAME);
  if(s->rname == NULL){
    fprintf(stderr,"cannot allocate memory: rname\n");
    abort();
  }
  s->cigar = (cigar_t*)malloc(sizeof(cigar_t)*LSEQ);
  if(s->cigar == NULL){
    fprintf(stderr,"cannot allocate memory: cigar\n");
    abort();
  }
  s->rnext = (char*)malloc(sizeof(char)*LNAME);
  if(s->rnext == NULL){
    fprintf(stderr,"cannot allocate memory: rnext\n");
    abort();
  }
  s->seq = (char*)malloc(sizeof(char)*LSEQ);
  if(s->seq == NULL){
    fprintf(stderr,"cannot allocate memory: seq\n");
    abort();
  }
  s->qual = (char*)malloc(sizeof(char)*LSEQ);
  if(s->qual == NULL){
    fprintf(stderr,"cannot allocate memory: qual\n");
    abort();
  }
  s->tmp = (char*)malloc(sizeof(char)*LSEQ);
  if(s->tmp == NULL){
    fprintf(stderr,"cannot allocate memory: tmp\n");
    abort();
  }
  s->unq = (char*)malloc(sizeof(char)*LSEQ);
  if(s->unq == NULL){
    fprintf(stderr,"cannot allocate memory: unq\n");
    abort();
  }
  return;
}

void init_sam2(sam_t * s, int max_maxins){
  s->qname = (char*)malloc(sizeof(char)*LNAME);
  if(s->qname == NULL){
    fprintf(stderr,"cannot allocate memory: qname\n");
    abort();
  }
  s->rname = (char*)malloc(sizeof(char)*LNAME);
  if(s->rname == NULL){
    fprintf(stderr,"cannot allocate memory: rname\n");
    abort();
  }
  s->cigar = (cigar_t*)malloc(sizeof(cigar_t)*LSEQ);
  if(s->cigar == NULL){
    fprintf(stderr,"cannot allocate memory: cigar\n");
    abort();
  }
  s->rnext = (char*)malloc(sizeof(char)*LNAME);
  if(s->rnext == NULL){
    fprintf(stderr,"cannot allocate memory: rnext\n");
    abort();
  }
  s->seq = (char*)malloc(sizeof(char)*LSEQ*max_maxins);
  if(s->seq == NULL){
    fprintf(stderr,"cannot allocate memory: seq\n");
    abort();
  }
  s->qual = (char*)malloc(sizeof(char)*LSEQ*max_maxins);
  if(s->qual == NULL){
    fprintf(stderr,"cannot allocate memory: qual\n");
    abort();
  }
  s->tmp = (char*)malloc(sizeof(char)*LSEQ*max_maxins);
  if(s->tmp == NULL){
    fprintf(stderr,"cannot allocate memory: tmp\n");
    abort();
  }
  s->unq = (char*)malloc(sizeof(char)*LSEQ*max_maxins);
  if(s->unq == NULL){
    fprintf(stderr,"cannot allocate memory: unq\n");
    abort();
  }
  return;
}

void reset_cigar(sam_t * s){
  int i;
  for(i=0; i<LSEQ; ++i){
    s->cigar[i].num = 0;
    s->cigar[i].sym = '\0';
  }
  s->cigar_length=0;
}

void short_reset_sam(sam_t * s){
  s->qname[0] = '\0';
  s->rname[0] = '\0';
  s->cigar_length=0;
  s->rnext[0] = '\0';
  s->seq[0] = '\0';
  s->qual[0] = '\0';
  s->tmp[0] = '\0';
  s->unq[0] = '\0';
  //for(i=0; i<LSEQ; ++i){
  //  s->cigar[i].num = 0;
   // s->cigar[i].sym = '\0';
  //}
  return;
}

void free_sam(sam_t * s){
  free(s->qname);
  free(s->rname);
  free(s->cigar);
  free(s->rnext);
  free(s->seq);
  free(s->qual);
  free(s->tmp);
  free(s->unq);
  return;
}

int opt_nisam=0;
int MAXINS=0;

int weighted_mode=0;
int vertical_mode=1;
int depth_comment_mode=0;
int depth_filter_mode=0;
int evalue_filter_mode=0;
int bit_score_filter_mode=0;
int gz_mode=0;
int fastq_mode=0;
int maxdepth = 50;
int valid_read_length_is_given=0;
int voter_limit_is_given=0;
int opt_chr_num_max=0;
int opt_chimeric_or_concatenated_filter=0;
int opt_debug=0;
int opt_quality_values=0;

void print_vertical(char * chr, char * buf2, int * orig_depths, int * chopped_depths, base_t ** rows, regions_t ** lists, int * nlists,unsigned long long max_end);

int main(int argc, char ** argv)
{
  int hitnum=0;
  max_read_length=(unsigned long long)(LSEQ);
  {
    int result;
    int tmp;
    while((result=getopt(argc,argv,"ic:wdHebv:l:fM:r:q")) != -1){
    //while((result=getopt(argc,argv,"icwdHebv:l:zfM:r:")) != -1)
      switch(result){
        case 'i':
          opt_nisam=1;
          ++hitnum;
          break;
        case 'c':
          opt_chimeric_or_concatenated_filter = atoi(optarg);
          if(opt_chimeric_or_concatenated_filter < 0){
            fprintf(stderr, "c: %d was given.\n",opt_chimeric_or_concatenated_filter);
            fprintf(stderr, "\tmust be >= 0.\n");
            abort();
          }
          hitnum+=2;
          break;
        case 'q':
          opt_quality_values=1;
          ++hitnum;
          break;
        case 'w':
          // dont use this mode
          vertical_mode=1;
          weighted_mode=1;
          ++hitnum;
          break;
        case 'd':
          vertical_mode=1;
          depth_filter_mode=1;
          ++hitnum;
          break;
        /*
        case 'd':
          depth_comment_mode=1;
          vertical_mode=1;
          weighted_mode=0;
          ++hitnum;
          break;
        */
        case 'H':
          // horizontal mode = not vertical mode
          vertical_mode=0;
          ++hitnum;
        case 'e':
          vertical_mode=1;
          evalue_filter_mode=1;
          ++hitnum;
          break;
        case 'b':
          vertical_mode=1;
          bit_score_filter_mode=1;
          ++hitnum;
          break;
        case 'v':
          VALID_VOTER = atoi(optarg);
          if(VALID_VOTER <= 0){
            fprintf(stderr, "VALID_VOTER must be > 0: %s\n", optarg);
            abort();
          }
          if(VALID_VOTER > 1024){
            fprintf(stderr, "VALID_VOTER must be <= 1024: %s\n", optarg);
            abort();
          }
          hitnum += 2;
          voter_limit_is_given=1;
          break;
        case 'l':
          VALID_LENGTH= atoi(optarg);
          if(VALID_LENGTH <= 0){
            fprintf(stderr, "VALID_LENGTH must be > 0: %s\n", optarg);
            abort();
          }
          if(VALID_LENGTH > 32768){
            fprintf(stderr, "VALID_LENGTH must be <= 32768: %s\n", optarg);
            abort();
          }
          hitnum += 2;
          valid_read_length_is_given=1;
          break;
//        case 'z':
//          gz_mode=1;
//          ++hitnum;
//          break;
        case 'f':
          fastq_mode=1;
          ++hitnum;
          break;
        case 'M':
          opt_chr_num_max=atoi(optarg);
          if(opt_chr_num_max < 0){
            fprintf(stderr, "M must be > 0: %s\n", optarg);
            abort();
          }
          hitnum += 2;
          break;
        case 'r':
          tmp = atoi(optarg);
          if(tmp <= 0){
            fprintf(stderr, "r(max_read_length) must be > 0: %s\n", optarg);
            abort();
          }
          max_read_length = (unsigned long long)tmp;
          hitnum += 2;
          break;
        case '?':
          printf("humei\n");
          break;
        default:
          break;
      }
    }
    if(evalue_filter_mode+depth_filter_mode+bit_score_filter_mode > 1){
      fprintf(stderr, "cannot set -e, -d and -b simultaneously\n");
      abort();
    }
  }

  MAXINS = max_ins;
  unsigned long long COLSIZE=((unsigned long long)(1+MAXINS))*max_read_length;
  LSEQ=max_read_length+1;
  int LBUF = (3*LSEQ);
  if(opt_chr_num_max == 0){
    if(argc != 2+hitnum)
    {
      fprintf(stderr, "USAGE: <this> <in.inv.sam|in.inv.sam.gz -z>\n");
      fprintf(stderr, "\tinput MUST be sorted by 1st chromosome name (must), 2nd evalue and 3rd bitScore\n");
      fprintf(stderr, "\t-e: evalue & bitScore filter. output format is vertical\n");
      fprintf(stderr, "\t-v <integer>: valid voter. We recommend 11\n");
      fprintf(stderr, "\t-q: print both bases and quality values in output\n");
      fprintf(stderr, "\t-c: chimeric or concatenated filter. we strongly recommend you use -c\n");
      fprintf(stderr, "\t-r <integer>: max read length. default value is 32768\n");

      return 1;
    }
  }

  char in_sam[LNAME];
  //char in_cnt[LNAME];
  //char in_maxinscnt[LNAME];
  //char in_fa[LNAME];
  strcpy(in_sam, argv[1+hitnum]);
  //strcpy(in_cnt, argv[2+hitnum]);
  //strcpy(in_maxinscnt, argv[3+hitnum]);
  //strcpy(in_fa, argv[2+hitnum]);

  FILE * IN_SAM;
//  gzFile ZN_SAM;
  if(strcmp("-",in_sam)==0){
    //fprintf(stderr, "sorry, don't use stdin\n");
    //return 1;
    IN_SAM = stdin;
  }
  else{
    if(gz_mode!=1){
      IN_SAM = fopen(in_sam,"r");
      if(IN_SAM == NULL){
        fprintf(stderr, "cannot open the file %s\n", in_sam);
        abort();
      }
    }
    else{
        fprintf(stderr, "cannot open the file %s\n", in_sam);
        abort();
//      ZN_SAM = gzopen(in_sam,"r");
//      if(ZN_SAM == NULL){
//        fprintf(stderr, "cannot open the file %s\n", in_sam);
//        abort();
//      }
    }
  }
  /*
  FILE * IN_CNT = fopen(in_cnt,"r");
  if(IN_CNT == NULL){
    fprintf(stderr, "cannot open the file %s\n", in_cnt);
    abort();
  }
  FILE * IN_MAXINSCNT = fopen(in_maxinscnt,"r");
  if(IN_MAXINSCNT == NULL){
    fprintf(stderr, "cannot open the file %s\n", in_maxinscnt);
    abort();
  }
  */
  char * buf = (char*)malloc(sizeof(char)*LBUF);
  if(buf == NULL){
    fprintf(stderr, "cannot allocate memory: buf\n");
    abort();
  }
  char * tmpcigar = (char*)malloc(sizeof(char)*LSEQ);
  if(tmpcigar == NULL){
    fprintf(stderr, "cannot allocate memory: tmpcigar\n");
    abort();
  }
  char * buf2 = (char*)malloc(sizeof(char)*LBUF);
  if(buf2 == NULL){
    fprintf(stderr, "cannot allocate memory: buf2\n");
    abort();
  }
  char * prevchr = (char*)malloc(sizeof(char)*LBUF);
  if(prevchr == NULL){
    fprintf(stderr, "cannot allocate memory: prevchr\n");
    abort();
  }
//  int * weights = (int*)malloc(sizeof(int)*LBUF);
//  if(weights == NULL){
//    fprintf(stderr, "cannot allocate memory: weights\n");
//    abort();
//  }
  int * orig_depths = (int*)malloc(sizeof(int)*COLSIZE);
  if(orig_depths == NULL){
    fprintf(stderr, "cannot allocate memory: orig_depths\n");
    abort();
  }
  {
    unsigned long long i;
    for(i=0ull; i<COLSIZE; ++i){
      orig_depths[i]=0;
    }
  }
  int * chopped_depths = (int*)malloc(sizeof(int)*COLSIZE);
  if(chopped_depths == NULL){
    fprintf(stderr, "cannot allocate memory: chopped_depths\n");
    abort();
  }
  {
    unsigned long long i;
    for(i=0ull; i<COLSIZE; ++i){
      chopped_depths[i]=0;
    }
  }

  //fprintf(stderr, "malloc is started\n");
  base_t ** rows = (base_t**)malloc(sizeof(base_t*)*(unsigned long long)(NROWS));
  if(rows == NULL){
    fprintf(stderr, "cannot allocate memory: rows\n");
    abort();
  }
  {
    int i;
    for(i=0;i<NROWS;++i){
      rows[i] = (base_t*)malloc(sizeof(base_t)*COLSIZE);
      if(rows[i] == NULL){
        fprintf(stderr, "cannot allocate memory: rows[%d]\n",i);
        abort();
      }
      unsigned long long j;
      for(j=0ull; j<COLSIZE; ++j){
        rows[i][j].base = ' ';
        if(opt_quality_values){
          rows[i][j].qv = ' ';
        }
//        rows[i][j].flag = 0;
      }
      //memset(rows[i], ' ', COLSIZE);
    }
    //printf("%llu\n",COLSIZE);
    //putchar(rows[0][540656]);
    //int j;
    //for(i=0;i<NROWS;++i){
    //  for(j=0; j<COLSIZE; ++j){
    //    putchar(rows[i][j]);
    //  }
    //}
    //return 0;
  }
  //fprintf(stderr, "rows is done\n");
  regions_t ** lists = (regions_t**)malloc(sizeof(regions_t*)*NROWS);
  if(lists == NULL){
    fprintf(stderr, "cannot allocate memory: lists\n");
    abort();
  }
  {
    int i;
    for(i=0;i<NROWS;++i){
      lists[i] = (regions_t*)malloc(sizeof(regions_t)*LISTSIZE);
      if(lists[i] == NULL){
        fprintf(stderr, "cannot allocate memory: lists[%d]\n",i);
        abort();
      }
    }
  }
  //fprintf(stderr, "lists is done\n");
  int * nlists = (int*)malloc(sizeof(int)*LISTSIZE);
  if(nlists == NULL){
    fprintf(stderr, "cannot allocate memory: nlists\n");
    abort();
  }
  {
    int i;
    for(i=0;i<LISTSIZE;++i){
      nlists[i]=0;
    }
  }
  //fprintf(stderr, "malloc is done\n");




/*
  int*every_num_u=(int*)malloc(sizeof(int)*chr_num_max);
  if(every_num_u==NULL){
    fprintf(stderr, "cannot allocate memory: every_num_u\n");
    abort();
  }
  int*every_max_ins=(int*)malloc(sizeof(int)*chr_num_max);
  if(every_max_ins==NULL){
    fprintf(stderr, "cannot allocate memory: every_max_ins\n");
    abort();
  }
  {
    int i;
    for(i=0; i<chr_num_max; ++i){
      every_num_u[i]=0;
      every_max_ins[i]=0;
    }
  }

  int r_chr_num;
  {
    strcpy(prevchr,"");
    int sretval;
    int chr_idx=-1;
    while((gz_mode != 1 && fgets(buf,LBUF,IN_SAM) != NULL) ||
    (gz_mode == 1 && gzgets(ZN_SAM,buf,LBUF) != NULL)){
    //while(fgets(buf,LBUF,IN_SAM) != NULL)
      sretval = sscanf(buf,"%*s %*d %s %*d %*d %s %*s %*d %*d %*s %*s %*s %*s\n",buf2,tmpcigar);
      //printf("%s\n",tmpcigar);
      if(sretval != 2){
        fprintf(stderr, "souteigai in.sam: retval %d\n",sretval);
        abort();
      }
      if(strcmp(prevchr,buf2)!=0){
        ++chr_idx;
        strcpy(prevchr, buf2);
      }
      if(chr_idx < chr_num_max)
        ++every_num_u[chr_idx];
      else{
        fprintf(stderr, "arienai %d %d\n",chr_idx,chr_num_max);
        abort();
      }

      {
        int offset=0;
        int len = strlen(tmpcigar);
        int j;
        int ret;
        int tmpoffset;
        int cigarlen;
        char cigarsym;
        //printf("%s\n",tmpcigar+offset);
        for(j=0; offset < len && j<LSEQ; ++j){
          ret = sscanf(tmpcigar+offset,"%d%c%n",&cigarlen,&cigarsym,&tmpoffset);
          //ret = sscanf(tmpcigar+offset,"%d%[HMDI]%d%[HDMI]%n",&cigarlen,&cigarsym,&foo,&bar,&tmpoffset);
          //printf("%s\n",tmpcigar+offset);
          //printf("kita %d %c\n",cigarlen,cigarsym);
          offset += tmpoffset;
          if(cigarsym == 'I' && cigarlen > every_max_ins[chr_idx]){
            every_max_ins[chr_idx] = cigarlen;
          }
        }
      }
    }
    if(gz_mode!=1)
      fseek(IN_SAM,0,SEEK_SET);
    else
      gzseek(ZN_SAM,0,SEEK_SET);
    r_chr_num=chr_idx+1;
  }
  int max_num_u=0;
  int max_maxins=0;
  {
    int i;
    for(i=0; i<r_chr_num; ++i){
      max_maxins = (every_max_ins[i] > max_maxins) ? every_max_ins[i] : max_maxins;
      max_num_u = (every_num_u[i] > max_num_u) ? every_num_u[i] : max_num_u;
      //printf("%d ",every_max_ins[i]);
      //printf("%d ",every_num_u[i]);
      //printf("\n");
    }
      //printf("\n");
  }
  //return 1;
*/

  int max_maxins = max_ins;
  sam_t * sams;
  sams = (sam_t*)malloc(sizeof(sam_t)*max_num_u);
  if(sams == NULL){
    fprintf(stderr, "cannot allocate memory: sams\n");
    abort();
  }
  {
    int i;
    for(i=0; i<max_num_u; ++i){
      init_sam2(&sams[i], 1+max_maxins);
      //init_sam2(&sams[i], 1+MAXINS);
    }
  }

  char prev_chr[LNAME];
  prev_chr[0] = '\0';
  int i;
  unsigned long long max_end=0ull;
  int discarded_info=1;
  for(i=0;((gz_mode != 1 && fgets(buf,LBUF,IN_SAM) != NULL)); i=0){
//  for(i=0;((gz_mode != 1 && fgets(buf,LBUF,IN_SAM) != NULL) || (gz_mode == 1 && gzgets(ZN_SAM,buf,LBUF) != NULL)); i=0)
    int sretval;
    if(i >= max_num_u){
      // ignore some units
      i=max_num_u-1;
    }
    short_reset_sam(&sams[i]);
    sams[i].cigar_length=0;
    if(opt_nisam == 1){
      sretval = sscanf(buf,"%s\t%d\t%s\t%d\t%d\t%s\t%s\t%d\t%d\t%s\t%s\t%s\t%s\n",
      sams[i].rname,
        &sams[i].flag,
        sams[i].qname,
        &sams[i].pos,  // 1-origin
        &sams[i].mapq,
        tmpcigar,
        sams[i].rnext,
        &sams[i].pnext,
        &sams[i].tlen,
        sams[i].seq,
        sams[i].qual,
        sams[i].as,
        sams[i].ev);
        sams[i].tlen = strlen(sams[i].seq);
    }
    else{
      sretval = sscanf(buf,"%s\t%d\t%s\t%d\t%d\t%s\t%s\t%d\t%d\t%s\t%s\t%s\t%s\n",
        sams[i].qname,
        &sams[i].flag,
        sams[i].rname,
        &sams[i].pos,  // 1-origin
        &sams[i].mapq,
        tmpcigar,
        sams[i].rnext,
        &sams[i].pnext,
        &sams[i].tlen,
        sams[i].seq,
        sams[i].qual,
        sams[i].as,
        sams[i].ev);
        sams[i].tlen = strlen(sams[i].seq);
    }
    if(sretval != 13){// XXX 13 may be changed
        fprintf(stderr, "souteigai sam: retval %d\n",sretval);
      fprintf(stderr, "%s\n",buf);
      abort();
    }
    if(strcmp("*",sams[i].qual) == 0){
      int len = strlen(sams[i].seq);
      int j;
      for(j=0; j<len; ++j){
        sams[i].qual[j] = '!';
      }
    }
    sretval = sscanf(sams[i].as, "AS:i:%d", &(sams[i].bit_score));
    if(sretval != 1){
      fprintf(stderr, "no alignment score ? : retval %d\n",sretval);
      fprintf(stderr, "%s\n",sams[i].as);
      fprintf(stderr, "%s\n",sams[i].qname);
      fprintf(stderr, "%s\n",sams[i].rname);
      abort();
    }
    sretval = sscanf(sams[i].ev, "EV:Z:%lf", &(sams[i].evalue));
    if(sretval != 1){
      fprintf(stderr, "no evalue ? : retval %d\n",sretval);
      fprintf(stderr, "%s\n",sams[i].ev);
      abort();
    }
    if(prev_chr[0] == '\0'){
      strcpy(prev_chr,sams[i].rname);
    }
    else if(strcmp(prev_chr,sams[i].rname) != 0){
      //fprintf(stderr, "%d\n",i);
      print_vertical(prev_chr,buf2,orig_depths,chopped_depths,rows,lists,nlists,max_end);
      /*
      if(i>=max_num_u-1){
        fprintf(stderr, "WARNING: too many hits. some hits are ignored. (1)\n");
      }
      */

      strcpy(prev_chr, sams[i].rname);
      //short_reset_sam(&sams[0]);
      //if(i != 0){
      //  fprintf(stderr,"kita\n");
      //}
      // CAUTION: i is always 0
      sam_t tmp = sams[0];
      sams[0] = sams[i];
      sams[i] = tmp;
      i=0;
      discarded_info=1;
      //for(i=0;i<NROWS;++i){
      //  memset(rows[i], ' ', COLSIZE);
      //}
      {
        int i;
        for(i=0;i<LISTSIZE;++i){
          nlists[i]=0;
        }
      }
      if(opt_chimeric_or_concatenated_filter)
      {
//        unsigned long long j;
//        for(j=0ull; j<=max_end; ++j){
//          orig_depths[j]=0;
//          chopped_depths[j]=0;
//        }
      }
      max_end = 0ull;

      //printf("kita\n");
      //continue;
    }

    int stt_cigar_index;
    int end_cigar_index;
    {
      int offset=0;
      int len = strlen(tmpcigar);
      int j;
      int ret;
      int tmpoffset;
      for(j=0; offset < len && j<LSEQ; ++j){
        ret = sscanf((tmpcigar+offset),"%d%c%n",&sams[i].cigar[sams[i].cigar_length].num,&sams[i].cigar[sams[i].cigar_length].sym,&tmpoffset);
        //ret = sscanf((tmpcigar+offset),"%d%[HMDI]%n",&sams[i].cigar[sams[i].cigar_length].num,&sams[i].cigar[sams[i].cigar_length].sym,&tmpoffset);
        if(ret != 2){
          printf("%s\n",tmpcigar);
          fprintf(stderr, "souteigai 1 ret: %d %s\n",ret, tmpcigar+offset);
          fprintf(stderr, "offset: %d \n",offset);
          abort();
        }
        offset += tmpoffset;
        ++sams[i].cigar_length;
      }
      stt_cigar_index=0;
      end_cigar_index=sams[i].cigar_length-1;
      if(offset != len){
        fprintf(stderr, "souteigai 2 %d %d\n", offset, len);
        abort();
      }
      if(sams[i].cigar[stt_cigar_index].sym == 'H'){
        ++stt_cigar_index;
      }
      if(sams[i].cigar[end_cigar_index].sym == 'H'){
        --end_cigar_index;
      }
      if(sams[i].cigar[stt_cigar_index].sym == 'I'){
        //fprintf(stderr,"WARNING: heading cigar\n");
        //fprintf(stderr,"souteigai 3 ins stt\n%s\n",tmpcigar);
        //fprintf(stderr,"souteigai ins stt\n%s\n",sam.cigar);
        //abort();
        sams[i].pos += sams[i].cigar[stt_cigar_index].num;
        sams[i].tlen -= sams[i].cigar[stt_cigar_index].num;
        ++stt_cigar_index;
      }
      if(sams[i].cigar[end_cigar_index].sym == 'I'){
        //fprintf(stderr,"WARNING: tailing cigar\n");
        //fprintf(stderr,"souteigai 4 ins end\n%s\n",tmpcigar);
        //abort();
        sams[i].tlen -= sams[i].cigar[end_cigar_index].num;
        --end_cigar_index;
      }
    }

    {
      int j;
      int loop = strlen(sams[i].seq);
      for(j=0; j<loop; ++j){
        switch((sams[i].seq)[j]){
          case 'a':
            (sams[i].seq)[j] = 'A';
            break;
          case 'c':
            (sams[i].seq)[j] = 'C';
            break;
          case 'g':
            (sams[i].seq)[j] = 'G';
            break;
          case 't':
            (sams[i].seq)[j] = 'T';
            break;
          case 'n':
            (sams[i].seq)[j] = 'N';
            break;
          case 'A':
            break;
          case 'C':
            break;
          case 'G':
            break;
          case 'T':
            break;
          case 'N':
            break;
          default:
            fprintf(stderr, "souteigai 5 %c\n%s\n",(sams[i].seq)[i],sams[i].seq);
            abort();
            break;
        }
      }
    }

    int seq_idx=0;
    int qual_idx=0;

    // expand CIGAR to read
    int overwhelmed_f=0;
    if(1)
    {
      int l;
      int tmp_idx=0;
      int unq_idx=0;
      for(l=stt_cigar_index; l <= end_cigar_index && l<LSEQ; ++l){
          //  fprintf(stderr, "%s\n",sams[i].qname);
          //int l;
          //for(l=stt_cigar_index; l<end_cigar_index; ++l){
          //  fprintf(stderr, "%d%c",sams[i].cigar[l].num,sams[i].cigar[l].sym);
          //} return 0;
        char mdi = (sams[i].cigar)[l].sym;
        int num  = (sams[i].cigar)[l].num;
        int j;
        int k;
        if(mdi == 'M' || mdi == 'D'){
          int insnum = MAXINS;
          // in first num-1, no ins exists
          for(j=0; j<num-1; ++j){
            if(mdi == 'M'){
              //putchar(sams[i].seq[seq_idx++]);
              (sams[i].tmp)[tmp_idx++] = (sams[i].seq)[seq_idx++];
              (sams[i].unq)[unq_idx++] = (sams[i].qual)[qual_idx++];
            }
            else if(mdi == 'D'){
              //putchar('-');
              (sams[i].tmp)[tmp_idx++] = '-';
              if(unq_idx == 0){
                (sams[i].unq)[unq_idx++] = '!';
              }
              else{
                (sams[i].unq)[unq_idx] = (sams[i].unq)[unq_idx-1];
                ++unq_idx;
              }
            }
            else{
              fprintf(stderr, "error %c\n",mdi);
              abort();
            }
            for(k=0; k<insnum; ++k){
              //putchar('-');
              (sams[i].tmp)[tmp_idx++] = '-';
              if(unq_idx == 0){
                (sams[i].unq)[unq_idx] = '!';
              }
              else{
                if(unq_idx < 1){
                  fprintf(stderr, "arienai 100\n");
                  abort();
                }
                (sams[i].unq)[unq_idx] = (sams[i].unq)[unq_idx-1];
              }
              ++unq_idx;
            }
          }
          // there may exist ins next to last one
          if(mdi == 'M'){
            //putchar(sam.seq[seq_idx++]);
            (sams[i].tmp)[tmp_idx++] = (sams[i].seq)[seq_idx++];
            (sams[i].unq)[unq_idx++] = (sams[i].qual)[qual_idx++];
          }
          else if(mdi == 'D'){
            //putchar('-');
            (sams[i].tmp)[tmp_idx++] = '-';
            if(unq_idx == 0){
              (sams[i].unq)[unq_idx] = '!';
            }
            else{
              if(unq_idx < 1){
                fprintf(stderr, "arienai 101\n");
                abort();
              }
              (sams[i].unq)[unq_idx] = (sams[i].unq)[unq_idx-1];
            }
            ++unq_idx;
          }
          else{
            fprintf(stderr, "error2 %c\n",mdi);
            abort();
          }
          if(l < end_cigar_index && (sams[i].cigar)[l+1].sym == 'I'){
            insnum -= (sams[i].cigar)[l+1].num;
          }
          for(k=0; k<insnum; ++k){
            //putchar('-');
            (sams[i].tmp)[tmp_idx++] = '-';
            if(unq_idx == 0){
              (sams[i].unq)[unq_idx] = '!';
            }
            else{
              if(unq_idx < 1){
                fprintf(stderr, "arienai 102\n");
                abort();
              }
              (sams[i].unq)[unq_idx] = (sams[i].unq)[unq_idx-1];
            }
            ++unq_idx;
          }
        }
        else if(mdi == 'I'){
          if(num > MAXINS){
            overwhelmed_f = 1;
            break;
            fprintf(stderr,"SKIPPED: rname: %s qname: %s MAXINS %d is overwhelmed by %d\n", sams[i].rname,sams[i].qname,MAXINS,num);
            for(j=0; j<MAXINS; ++j){
              (sams[i].tmp)[tmp_idx++] = (sams[i].seq)[seq_idx++];
              (sams[i].unq)[unq_idx++] = (sams[i].qual)[qual_idx++];
            }
            for(j=MAXINS; j<num; ++j){
              ++seq_idx;
              ++qual_idx;
              //(sams[i].tmp)[tmp_idx++] = (sams[i].seq)[seq_idx++];
              //(sams[i].unq)[unq_idx++] = (sams[i].qual)[qual_idx++];
            }
            //abort();
          }
          else{
            for(j=0; j<num; ++j){
              //putchar(sam.seq[seq_idx++]);
              (sams[i].tmp)[tmp_idx++] = (sams[i].seq)[seq_idx++];
              (sams[i].unq)[unq_idx++] = (sams[i].qual)[qual_idx++];
            }
          }
        }
        else{
          fprintf(stderr, "arie nai %c %d\n", mdi, num);
          int m;
          for(m=0; m<sams[i].cigar_length; ++m){
            fprintf(stderr, "%d%c",(sams[i].cigar)[m].num,(sams[i].cigar)[m].sym);
          }
          abort();
        }
      }
      if(overwhelmed_f){
        continue;
      }
      (sams[i].tmp)[tmp_idx] = '\0';
      (sams[i].unq)[unq_idx] = '\0';
      // swap
      char * tmp;
      tmp = sams[i].seq;
      sams[i].seq = sams[i].tmp;// expanded read by CIGAR
      sams[i].tmp = tmp;// original read
      char * unq;
      unq = sams[i].qual;
      sams[i].qual = sams[i].unq;
      sams[i].unq = unq;

      sams[i].tlen = strlen(sams[i].seq);// tlen is used as seq-len in this program
      if(strlen(sams[i].seq) != strlen(sams[i].qual)){
        fprintf(stderr, "bug: seq len differs from qual len.\n");
        abort();
      }
      //putchar('\n');

      // count mdi-len
      sams[i].mapq =0;// mapq is used as mdi-len in this program
      for(l=stt_cigar_index; l <= end_cigar_index && l<LSEQ; ++l){
        sams[i].mapq += (sams[i].cigar)[l].num;
      }
    }
    int num_u=1;
    {
    //  int tmplen = (1+max_maxins)*LSEQ;
      int i;
      // chop '-' tail
      for(i=0; i<num_u; ++i){
        //while((sams[i].seq)[sams[i].tlen-1] == '-' || (sams[i].seq)[sams[i].tlen-1] == ' ')
        while((sams[i].seq)[sams[i].tlen-1] == '-'){
          (sams[i].seq)[sams[i].tlen-1]='\0';
          --sams[i].tlen;
          if(sams[i].tlen == 0){
            fprintf(stderr, "arienai sams[%d].tlen == 0\n",i);
            abort();
          }
        }
      }
    }

    {
      int i;
      for(i=0; i<num_u; ++i){// CAUTION: num_u is dummy, and always 1.
        //(1+MAXINS)*(sams[i].pos-1)+sams[i].tlen-1)
        //int stt = sams[i].pos-1;// 0-originise
        unsigned long long stt;
        if(sams[i].pos == 0){
          fprintf(stderr,"positions in SAM format must be 1-origin\n");
          exit(1);
        }
        stt = (unsigned long long)(sams[i].pos-1);// 0-originise
        stt *= (unsigned long long)(1+MAXINS);
        unsigned long long end = stt;
        end += (unsigned long long)(sams[i].tlen-1);
        // these lines must not be here, because this unit may be discarded
        //if(max_end < end){
        //  max_end = end;
        //}
        int j;
        int set=0;
        int not_collide;
        for(j=0,not_collide=1; j<NROWS; ++j,not_collide=1){
          // find a free region
          // XXX it may be better to use heap structure
          int l;
          for(l=0; l<nlists[j]; ++l){
            if(end+INTERVAL < lists[j][l].stt || stt > lists[j][l].end+INTERVAL){
              continue;
            }
            else{
              not_collide=0;
            }
          }
          if(not_collide==1 && nlists[j] <= LISTSIZE){
            // column[j] is free
            unsigned long long k;
            for(k=stt; k<=end && k<COLSIZE; ++k){
              rows[j][k].base = (sams[i].seq)[k-stt];
              if(opt_quality_values){
                rows[j][k].qv = (sams[i].qual)[k-stt];
              }
            }
            lists[j][nlists[j]].stt = stt; 
            lists[j][nlists[j]].end = end; 
            ++nlists[j];
            set=1;
            if(max_end < end){
              if(end >= COLSIZE){
                fprintf(stderr, "nande?\n");
                fprintf(stderr, "end %llu\n",end);
                fprintf(stderr, "COLSIZE %llu\n",COLSIZE);
                return 1;
              }
              max_end = end;
            }
            // depths
            if(opt_chimeric_or_concatenated_filter)
            {
              unsigned long long s;
              for(s=stt; s<=end && s<COLSIZE; ++s){
                //++orig_depths[s];
              }
              int chopped=42;
              for(s=stt+(MAXINS+1)*chopped; s<=end-(MAXINS+1)*chopped && s<COLSIZE; ++s){
                //++chopped_depths[s];
                //rows[j][s].flag = 1;
              }
              int s_end;
              s_end = stt+(MAXINS+1)*chopped;
              for(s=stt; s<s_end; ++s){
//                rows[j][s].flag = 1;// term
              }
              s_end = end;
              for(s=end-(MAXINS+1)*(chopped-1); s<=end; ++s){
//                rows[j][s].flag = 1;// term
              }
            }
            break;
          }
          else{
            continue;
          }
        }
        if(set == 0 && discarded_info==1){
          if(opt_debug){
            fprintf(stderr, "WARNING: too many reads. some are discarded\n");
            fprintf(stderr, "\t%s\n",prev_chr);
          }
          discarded_info=0;
        }
      }
    }
  }
  if(1){
    print_vertical(prev_chr,buf2,orig_depths,chopped_depths,rows,lists,nlists,max_end);
    //fprintf(stderr, "%d\n",i);
    /*
    if(i>=max_num_u-1){
      fprintf(stderr, "WARNING: too many hits. some hits are ignored. (2)\n");
    }
    */
  }


  //fprintf(stderr, "now closing\n");
  if((gz_mode != 1 && strcmp("-",in_sam) != 0 && fgets(buf,LBUF,IN_SAM) != NULL)){
//  if((gz_mode != 1 && strcmp("-",in_sam) != 0 && fgets(buf,LBUF,IN_SAM) != NULL) ||
//    (gz_mode == 1 && gzgets(ZN_SAM,buf,LBUF) != NULL))
    fprintf(stderr, "not reach the end of %s\n",in_sam);
    abort();
  }

  {
    int i;
    for(i=0; i<max_num_u; ++i){
      free_sam(&sams[i]);
    }
  }
  free(sams);
  if(gz_mode != 1){
    if(strcmp("-",in_sam)!=0)
      fclose(IN_SAM);
  }
  else{
//    gzclose(ZN_SAM);
  }
  //fclose(IN_CNT);
  free(buf);
  free(tmpcigar);
  free(buf2);
  free(prevchr);
//  free(weights);
  free(orig_depths);
  free(chopped_depths);
  {
    int i;
    for(i=0;i<NROWS;++i){
      free(rows[i]);
    }
    free(rows);
  }
  //fprintf(stderr,"freeing rows done\n");
  {
    int i;
    for(i=0;i<NROWS;++i){
      free(lists[i]);
    }
    free(lists);
  }
  //fprintf(stderr,"freeing lists done\n");
  free(nlists);

  return 0;
}

void print_vertical(char * chr, char * buf2, int * orig_depths, int * chopped_depths, base_t ** rows, regions_t ** lists, int * nlists,unsigned long long max_end){

/*
cccc
oooo
llll
0123...
*/

  {
    //fprintf(stderr, "setting is done\n");
    // print
    unsigned long long i;
    int j;
//    fprintf(stderr, "chr is printed\n");
    int n_usedrows=0;
    for(i=0ull; i<NROWS; ++i){
      if(nlists[i] == 0){
        n_usedrows = i;
        break;
      }
    }
    if(i>=NROWS){
      n_usedrows = NROWS;
    }
    //fprintf(stderr, "n_usedrows is defined. max_end \n");
    //char * buf = sams[0].seq; // suppose we no longer use sams.
    char buf[BUFSIZE];
    char qvs[BUFSIZE];
    int max_coldepth=0;
    for(i=0ull; i<=max_end; ++i){
      for(j=0; j<n_usedrows; ++j){
        buf[j] = rows[j][i].base;
        if(opt_quality_values){
          qvs[j] = rows[j][i].qv;
        }
      }
      buf[j] = '\0';
      if(opt_quality_values){
        qvs[j] = '\0';
      }
      // VALID_VOTER
      {
        int len = strlen(buf);
        int k;
        int voter=0;
        for(k=0;k<len;++k){
          if(buf[k] != ' '){
            ++voter;
            if(voter >= VALID_VOTER){
              max_coldepth = (max_coldepth < k+1) ? k+1 : max_coldepth;
              int l;
              for(l=k+1; l<n_usedrows; ++l){
                rows[l][i].base = ' ';// delete invalid voters, not only to initialize
                if(opt_quality_values){
                  rows[l][i].qv = ' ';
                }
              }
              break;
            }
          }
        }
      }
    }
    if(max_coldepth == 0){// when VALID_VOTER is large
      max_coldepth = n_usedrows;
    }
    // chop terminal '-'s in each column
    for(j=VALID_VOTER; j<max_coldepth; ++j){
      if(rows[j][0].base == '-'){
        rows[j][0].base = ' ';
        if(opt_quality_values){
          rows[j][0].qv = ' ';
        }
      }
      if(rows[j][max_end].base == '-'){
        rows[j][max_end].base = ' ';
        if(opt_quality_values){
          rows[j][max_end].qv = ' ';
        }
      }
      for(i=1ull; i<max_end; ++i){
        if(rows[j][i].base == '-'){
          if(rows[j][i-1ull].base == ' '){
            rows[j][i].base = ' ';
            if(opt_quality_values){
              rows[j][i].qv = ' ';
            }
          }
          else if(rows[j][i+1ull].base == ' '){
            unsigned long long l;
            for(l=i; rows[j][l].base == '-' && l>0ull; --l){
              rows[j][l].base = ' ';
              if(opt_quality_values){
                rows[j][l].qv = ' ';
              }
            }
            ++i;
          }
        }
      }
    }

    // chop short frags in both terminal 42 bases regions
    /*
    {
      int i;
      int j;
      int term=42*(1+MAXINS);
      for(i=0; i<max_coldepth; ++i){
        for(j=0; j<term; ++j){
          int len;
          int k;
          if(rows[i][j].base != ' '){
            len=1;
            for(k=j+1; k<term; ++k){
              if(rows[i][k].base != ' '){
                ++len;
              }
              else{
                break;
              }
            }
            if(k >= term){
              break;
            }
            else{
              int from;
              for(from=j;from < k; ++from){
                rows[i][from].base = ' ';
                if(opt_quality_values){
                  rows[i][from].qv = ' ';
                }
              }
            }
            j=k;
            --j;
          }
        }
        for(j=max_end; j>max_end-term; --j){
          int len;
          int k;
          if(rows[i][j].base != ' '){
            int from = j;
            len=1;
            for(k=j-1; k>max_end-term; --k){
              if(rows[i][k].base != ' '){
                ++len;
              }
              else{
                break;
              }
            }
            if(k <= max_end-term){
              break;
            }
            else{
              for(;from > k; --from){
                rows[i][from].base = ' ';
                if(opt_quality_values){
                  rows[i][from].qv = ' ';
                }
              }
            }
            j=k;
            ++j;
          }
        }
      }
    }
    */

    // chimeric or concatenated filter
    /*
    if(opt_chimeric_or_concatenated_filter){
      if(1){
        for(i=0ull; i<=max_end; ++i){
          int od=0;
          int cd=0;
          for(j=0; j<max_coldepth; ++j){
            if(rows[j][i].base != ' '){
              ++od;
              if(rows[j][i].flag==0){// not term
                ++cd;
              }
            }
          }
          orig_depths[i] = od;
          chopped_depths[i] = cd;
        }
      }
      for(i=0ull; i<=max_end; ++i){
        if(orig_depths[i]<valid_depth){
          chopped_depths[i] = -1;
        }
      }
      chopped_depths[0ull] = -1;
      chopped_depths[max_end] = -1;
      for(i=0ull; i<=max_end; ++i){
        if(chopped_depths[i]==-1){
          unsigned long long j;
          for(j=i-1ull; chopped_depths[j] >= 0 && chopped_depths[j]<valid_depth; --j){
            chopped_depths[j]=-1;
            if(j==0ull){
              break;
            }
          }
          for(i=i+1ull; i<=max_end && chopped_depths[i] >= 0 && chopped_depths[i]<valid_depth; ++i){
            chopped_depths[i]=-1;
          }
          --i;
        }
      }
      for(i=0ull; i<=max_end; ++i){
        if(chopped_depths[i] >= 0 && chopped_depths[i]<valid_depth){
          // suspecte the regions are chimeric or concatenated
          if(buf[0] == ' '){
            fprintf(stderr, "souteigai depth\n");
            fprintf(stderr, "%s\n",buf);
            abort();
          }
          int j;
          for(j=1; j<max_coldepth; ++j){
            rows[j][i].base = ' ';
            if(opt_quality_values){
              rows[j][i].qv = ' ';
            }
          }
        }
      }
    }
    */

    // chop short (<valid_fragment_length) fragments
    {
      int i;
      int valid_fragment_length = 42;
      unsigned long long j;
      int DEBUG;
      for(i=max_coldepth-1; i>=0; --i){
        int frags_exist=0;
        for(j=0ull; j<=max_end; ++j){
          int len;
          unsigned long long k;
          if(rows[i][j].base != ' '){
            len=1;
            for(k=j+1ull; k<=max_end; ++k){
              if(rows[i][k].base != ' '){
                ++len;
              }
              else{
                break;
              }
            }
            if(len >= valid_fragment_length*(1+MAXINS)){
              frags_exist=1;
            }
            else{
              int from;
              for(from=j;from < k; ++from){
                rows[i][from].base = ' ';
                if(opt_quality_values){
                  rows[i][from].qv = ' ';
                }
              }
            }
            j=k;
          }
          DEBUG = len;
        }
        if(frags_exist){
        }
        else{
          if(i<1 || max_coldepth<1){
            fprintf(stderr, "WARNING: if query %s is not short, nss2v may contain bugs.\n",chr);
            return;
            //fprintf(stderr, "souteigai 400 chr : %s i: %d max_coldepth %d len: %d stt: %llu end: %llu\n",chr,i,max_coldepth,DEBUG,lists[0][0].stt, lists[0][0].end);
            //abort();
          }
          base_t * tmp;
          tmp = rows[i];
          rows[i] = rows[max_coldepth-1];
          rows[max_coldepth-1] = tmp;
          --max_coldepth;
        }
      }
    }

    // print
    printf("%%%s\n",chr);
    for(i=0ull; i<=max_end; ++i){
      for(j=0; j<max_coldepth; ++j){
        buf[j] = rows[j][i].base;
        if(opt_quality_values){
          qvs[j] = rows[j][i].qv;
        }
      }
      buf[j] = '\0';
      if(opt_quality_values){
        qvs[j] = '\0';
      }
      for(j=0; j<max_coldepth; ++j){
        if(buf[j] != ' ' && buf[j] != '-'){
          if(0){
          //if(opt_chimeric_or_concatenated_filter && chopped_depths[i] >= 0 && chopped_depths[i]<valid_depth)
            if(buf[0] == ' '){
              fprintf(stderr, "souteigai depth\n");
              fprintf(stderr, "%s\n",buf);
              abort();
            }
            if(opt_quality_values){
              printf("%c\t%c\n",buf[0],qvs[0]);
            }
            else{
              printf("%c\n",buf[0]);
            }
          }
          else{
            if(opt_quality_values){
              printf("%s\t%s\n",buf,qvs);
            }
            else{
              printf("%s\n",buf);
            }
            //printf("%s\t%d\t%d\n",buf,orig_depths[i],chopped_depths[i]);
          }
          break;
        }
      }
    }
    printf("\n");

    // initialize
    for(j=0; j<n_usedrows; ++j){
      for(i=0ull; i<=max_end; ++i){
        rows[j][i].base = ' ';
        if(opt_quality_values){
          rows[j][i].qv = ' ';
        }
//        rows[j][i].flag = 0;
      }
    }
  }
//  fprintf(stderr, "returning now\n");


    return;
}
